<?php
  #-------------------------------------------#
  #                                           #
  #       PHP QuickBooks Service for X-CART   #
  #       Copyright (c) 2006-2012             #
  #       Atandra LLC.                        #
  #       www.atandra.com                     #
  #                                           #
  #-------------------------------------------#

  error_reporting(E_ALL && ~E_NOTICE );
  set_time_limit  ( 50  );
  define('SKIP_COOKIE_CHECK', true);
  define('USE_TRUSTED_POST_VARIABLES', true);
  $trusted_post_variables = array('request');

  DEFINE(__ENCODE_RESPONSE, true);
  DEFINE(__TIME_METERING, false);
  DEFINE(__MB_DEBUG, false);

//  DEFINE('XCART_START',1);


    // DO NOT DOWNLOAD ORDERS IN FAILED, DECLINED AND NOT FINISHED STATES
	//I=Not finished
	//Q=Queued
	//P=Processed
	//B=Backordered
	//D=Declined
	//F=Failed
	//C=Complete
  DEFINE("QB_ORDERS_DOWNLOAD_EXCL_LIST", " and o.status NOT IN ('F','D', 'I') ");

    // DOWNLOAD ORDERS (RETURNS) IN Return Authorize, Return Requested AND Return Complited STATES
  // Return Authorize - A,
  // Return Requested - R,
  // Return Declined - D,
  // Return Complited - C,
  // Removed by costomer - ???
  DEFINE("QB_RETURNS_STATUS_LIST", " and r.status  IN ('R','C','A') ");

//  $xcart_dir = '../';

// ########    the below lines should be used for x-cart version 4.1.10 or earlier ######################
//  require "../smarty.php";
//  include "../config.php";
//  include $xcart_dir."init.php";
//  include $xcart_dir."include/func/func.crypt.php";
//  include $xcart_dir."include/func/func.order.php";
// ######################################################################################################
  
// ########    the below lines should be used for x-cart version 4.1.11 or later ########################

 define('FORM_ID_DISABLED', 1);

  require './auth.php';
//////////////////////////////////////////////  require $xcart_dir.'/include/security.php';

   //x_load("crypt", "order", "user");
   x_load("crypt", "order");
// ######################################################################################################
 
  require('thubxml.php');

  $PHP_SELF = (isset($_SERVER['PHP_SELF']) ? $_SERVER['PHP_SELF'] : $_SERVER['SCRIPT_NAME']);

  //  *****************************************************
  // Retrieve STORE_NAME and ID
  $user_id = "";

  $sqlstr="SELECT * from ".$sql_tbl[config]." where name='company_name'";
  $res = db_query($sqlstr);
  if (db_num_rows($res) == 0 ){
    DEFINE("STORE_NAME","WEB_STORE");
    DEFINE("STORE_NAME_ID","WQB1");
  } else {
    $row = db_fetch_array($res);
    //DEFINE("STORE_NAME", parseSpecCharsA($row['value']));
    //DEFINE("STORE_NAME_ID", parseSpecCharsA($row['value']));
    DEFINE("STORE_NAME", substr(htmlspecialchars($row['value'], ENT_NOQUOTES), 0, 75));
    DEFINE("STORE_NAME_ID", substr(htmlspecialchars($row['value'], ENT_NOQUOTES), 0, 75));
  }

  $sqlstr="SELECT * from ".$sql_tbl[config]." where name='version'";
  $res = db_query($sqlstr);
  if (db_num_rows($res) == 0 ){
    DEFINE("XCART_VERSION","4.1");
  } else {
    $row = db_fetch_array($res);
    DEFINE("XCART_VERSION", substr(htmlspecialchars($row['value'], ENT_NOQUOTES), 0, 3));
  }


  //echo "XCART-VERSION=".XCART_VERSION;


  if (empty($request)) exit;

  // parse XML Request
  $request = trim(stripcslashes($request));
  $xmlRequest = new xml_doc($request);
  $xmlRequest->parse();
  $xmlRequest->getTag(0, $_tagName, $_tagAttributes, $_tagContents, $_tagTags);
	
  if (strtoupper(trim($_tagName)) != 'REQUEST') {
    print(xmlErrorResponse('unknown', '9997', 'Unknown request', STORE_NAME, ''));flush;exit;
  }
  if (count($_tagTags) == 0) {
    print(xmlErrorResponse('unknown', '9996', 'REQUEST tag doesnt have necessry parameters', STORE_NAME, ''));flush;exit;
  }
    $RequestParams = Array();
    foreach ($_tagTags as $k=>$v){
    $xmlRequest->getTag($v, $tN, $tA, $tC, $tT);
    $RequestParams[strtoupper($tN)] = trim($tC);
  }
  if (!isset($RequestParams['COMMAND'])) {
    print(xmlErrorResponse('unknown', '9995', 'Command is not set', STORE_NAME, '')); exit;
  }
  $RequestParams['COMMAND'] = strtoupper($RequestParams['COMMAND']);
  if(
         ($RequestParams['COMMAND'] != ('GET'.'ORDERS'))
      && ($RequestParams['COMMAND'] != ('UPDATE'.'ORDERS'))
      && ($RequestParams['COMMAND'] != ('UPDATE'.'ORDERS'.'SHIPPING'.'STATUS'))
      && ($RequestParams['COMMAND'] != ('UPDATE'.'INVENTORY'))
    ) {
        print(xmlErrorResponse('unknown', '9999', 'Unknown Command'.$RequestParams['COMMAND'], STORE_NAME, ''));exit;
  }
  if (isset($RequestParams['REQUESTID'])) $request_id = $RequestParams['REQUESTID'];

    //  *****************************************************
    //  AUTH user

    if (isset($RequestParams['USERID']))
    $user_id = $RequestParams['USERID'];
    else {
    print(xmlErrorResponse('authorization', '255', 'failed', STORE_NAME, ''));
    exit;
    }
    if (isset($RequestParams['PASSWORD']))
    $user_password = $RequestParams['PASSWORD'];
    else {
    print(xmlErrorResponse('authorization', '254', 'failed', STORE_NAME, ''));
    exit;
    }
    //$sqlstr="SELECT * from ".$sql_tbl[customers]." where login='".addslashes($user_id)."'";
    $sqlstr="SELECT * from ".$sql_tbl[customers]." where (login='".addslashes($user_id)."' OR email = '".addslashes($user_id)."' ) AND usertype = 'P'";
 
	$auth_handle = db_query($sqlstr);
	if (db_num_rows($auth_handle) == 0 ){  print(xmlErrorResponse('authorization', '253', 'failed getting user information for ['. addslashes($user_id) . "]. You probably have mutiple users on your x-cart admin with this same email." , STORE_NAME, '')); exit; }
	$user = db_fetch_array($auth_handle);
	
	//Condition added to differentiate versions from 4.4
    if(XCART_VERSION >= 4.5){  //Ganesh 23032012
				$log  = "user_password: ".var_export($user_password, true)."\n";
				$log .= "user: ".var_export($user['password'], true)."\n";
				$log .= "POST: ".var_export($_POST, true)."\n";
				$log .= "GET: ".var_export($_GET, true)."\n";
				x_log_add('snake', $log, true);
			
				$passInDB = $user['password'];
				$passDecryptDB = text_decrypt($user['password']);
				#  $user['password'] = text_decrypt($user['password']);
			    
			    
			    
			    
			  //$crypted = addslashes(text_crypt(text_hash($user_password)));
			  $crypted = text_decrypt($user['password']);
				$crypted1 = addslashes(text_crypt($user_password));
			  
				list($is_password_correct, $password_has_old_format) = func_is_password_correct($user_password, $user['password']);
			
			
			
			$passwordPHP_AUTH_PW = stripslashes($_SERVER['PHP_AUTH_PW']);
			
			
			 	if(!$is_password_correct) { 
			 	//if($user_password != $passDecryptDB) { 
			 	//if($passDecryptDB != $crypted) { 
					$log = "PASSWORD INCORRECT: ".var_export($user['password'], true)."\n";
					$log .= "ggg: ".var_export($user_password, true)."\n";
					x_log_add('snake', $log, true);
					
					print(xmlErrorResponse('authorization failed-111/$passInDB/$passDecryptDB/$user_password/$crypted/$passwordPHP_AUTH_PW  : '. $passInDB." / ". $passDecryptDB." / ".$user_password." / ".$crypted . " / ". $passwordPHP_AUTH_PW , '251','failed/$passInDB/$passDecryptDB/$user_password' + $user_password, STORE_NAME, '')); 
					exit; 
				}
    }else{ //Ganesh 23032012   // else of XCART_VERSION >= 4.5
    $passInDB = $user['password'];
    $passDecryptDB = text_decrypt($user['password']);
    $user['password'] = text_decrypt($user['password']);
    //if( $user['password'] != $user_password) { print(xmlErrorResponse('authorization', '251','failed', STORE_NAME, '')); exit; }
 	//if( $user['password'] != $user_password) { 
 	if( $user['password'] != $passDecryptDB) { 
 				
 				print(xmlErrorResponse('authorization failed-222/$passInDB/$passDecryptDB/$user_password : '. $passInDB." / ". $passDecryptDB." / ".$user['password'], '251','authorization failed/$passInDB/$passDecryptDB/$user_password : '. $passInDB." / ". $passDecryptDB." / ".$user['password'], STORE_NAME, '')); exit; }
    } //Ganesh 23032012

  if (isset($RequestParams['LIMITORDERCOUNT']))
    DEFINE("QB_ORDERS_PER_RESPONSE", $RequestParams['LIMITORDERCOUNT']);
  else
    DEFINE("QB_ORDERS_PER_RESPONSE", 25);

  if (isset($RequestParams['NUMBEROFDAYS']))
    define(QB_NUMBER_OF_DAYS, $RequestParams['NUMBEROFDAYS']);
  else
    define(QB_NUMBER_OF_DAYS, 10);
    define(QB_NUMBER_OF_DAYS_RETURN, 5);

  if (isset($RequestParams['ORDERSTARTNUMBER'])){
    define(QB_ORDER_START_NUMBER, $RequestParams['ORDERSTARTNUMBER']);
  } else {
    define(QB_ORDER_START_NUMBER, 0);
  }

 // if (isset($RequestParams['EXCLUDE-ORDERS'])) {
 //   $exclude_orders = trim($RequestParams['EXCLUDE-ORDERS']);
 //   if (empty($exclude_orders)) unset($exclude_orders);
 // }

  $xmlResponse = new xml_doc();
  $xmlResponse->version='1.0';
  $xmlResponse->encoding='ISO-8859-1';
  $root = $xmlResponse->createTag("RESPONSE", array('Version'=>'1.6'));
  $envelope = $xmlResponse->createTag("Envelope", array(), '', $root);
  $xmlResponse->createTag("Command", array(), $RequestParams['COMMAND'], $envelope);

  //  *****************************************************
  //  COMMAND  Case

  switch ($RequestParams['COMMAND']){
    //***************************************************
    //
    //      get Orders Service
    //
    //***************************************************

    case 'GETORDERS' : {
      $timer = new timerClass();
      if (isset($request_id)) $xmlResponse->createTag("RequestID", array(), $request_id, $envelope);
      $xmlResponse->createTag("StoreID",   array(), STORE_NAME_ID, $envelope);
      $xmlResponse->createTag("StoreName", array(), STORE_NAME, $envelope);
      $timer->start();
		$list_orders =  array();
      //AND to_days(Now()) - TO_DAYS(FROM_UNIXTIME(o.date)) <=5
		 	$str_date_filter = "";
		 	if (QB_ORDER_START_NUMBER == 0) {
		 		$str_date_filter = " AND to_days(Now()) - TO_DAYS(FROM_UNIXTIME(o.date)) <= ".QB_NUMBER_OF_DAYS;
			}

	  $sql_str = "
        SELECT
          COUNT(*) cnt
        FROM " . $sql_tbl[orders] . " o
        WHERE o.orderid >".QB_ORDER_START_NUMBER."
         ".QB_ORDERS_DOWNLOAD_EXCL_LIST."
         ".$str_date_filter."
        ".(QB_ORDERS_PER_RESPONSE>0?"LIMIT 0, ".QB_ORDERS_PER_RESPONSE:'');

//echo $sql_str;

      $orders_query = db_query($sql_str);
      $row = db_fetch_array($orders_query);

	  $no_orders = false;
      if ($row['cnt']==0) {
        $no_orders = true;
      }

      $xmlResponse->createTag("StatusCode", array(), $no_orders?"1000":"0", $envelope);
      $xmlResponse->createTag("StatusMessage", array(), $no_orders?"No Orders returned":"All Ok", $envelope);
      $xmlResponse->createTag("xcartversion", array(), XCART_VERSION, $envelope);


	  if ($no_orders){
	//	  header("Content-type: application/xml");
		  print($xmlResponse->generate()); flush; exit;
      }

//*************************************
        //      Returns
        //*************************************
        // Test active modules RMA
        $items_query_raw = "SELECT m.* FROM ".$sql_tbl[modules]." m  WHERE m.module_name = 'RMA' and m.active ='Y' ";

        $items_query = db_query($items_query_raw);

		if (db_num_rows($items_query) != 0 ){
			$fl_module_RMA = true;
		} else{	$fl_module_RMA = false;}

      $ordersNode = $xmlResponse->createTag("Orders", array(), '', $root);

      $orders_query_raw = "
        SELECT o.discount+o.coupon_discount as full_discount,o.giftcert_discount, o.*,s.shipping as ship_title
        FROM ".$sql_tbl[orders]." o LEFT JOIN ".$sql_tbl[shipping]." s ON s.shippingid = o.shippingid
        WHERE o.orderid >".QB_ORDER_START_NUMBER."
         ".QB_ORDERS_DOWNLOAD_EXCL_LIST."
         ".$str_date_filter."
        GROUP BY o.orderid
        ORDER BY o.orderid
        ".(QB_ORDERS_PER_RESPONSE>0?" LIMIT 0, ".QB_ORDERS_PER_RESPONSE:'');

      // $xmlResponse->createTag("_OrdersQuery", array(), $orders_query_raw, $ordersNode);
      $orders_query = db_query($orders_query_raw);

      if (__TIME_METERING){
        $xmlResponse->createTag("_TIMER1",  array(), "orders queried from db ".$timer->end(), $ordersNode);
        $timer->start();
      }
	  $fl_return_item = true;

      while ($oInfo = db_fetch_array($orders_query)) {
        $timer1 = new timerClass();
        $timer1->start();

        $oInfo = parseSpecCharsA($oInfo);

        $orderNode  = $xmlResponse->createTag("Order",  array(), '', $ordersNode);
		$xmlResponse->createTag("TransactionType",  array(), "Sale", $orderNode, __ENCODE_RESPONSE);

        // Orders/Order info
        $xmlResponse->createTag("OrderID",  array(), $oInfo['orderid'],     $orderNode);
        $xmlResponse->createTag("Date",     array(), date("Y-m-d",$oInfo['date']), $orderNode); //date
        $xmlResponse->createTag("Time",     array(), date("H:i:s",$oInfo['date']), $orderNode); //time
        $xmlResponse->createTag("StoreId",  array(), STORE_NAME_ID,        $orderNode, __ENCODE_RESPONSE);
        $xmlResponse->createTag("StoreName",array(), STORE_NAME,           $orderNode, __ENCODE_RESPONSE);
        $xmlResponse->createTag("Currency", array(), "USD",           $orderNode, __ENCODE_RESPONSE);
    //  $xmlResponse->createTag("TimeZone", array(), 'PST',                 $orderNode);

        $itemsNode  = $xmlResponse->createTag("Items",  array(), '', $orderNode);
        $billNode  = $xmlResponse->createTag("Bill",    array(), '', $orderNode);
        $shipNode  = $xmlResponse->createTag("Ship",    array(), '', $orderNode);
        $chargesNode  = $xmlResponse->createTag("Charges", array(), '', $orderNode);
        $extra = unserialize($oInfo['extra']);

        #  // Orders/Bill/CreditCard info

        $shipto = '';
        if (!empty($oInfo['details']))        {

          $timer2 = new timerClass();
          $timer2->start();

          $oInfo['details'] = text_decrypt($oInfo['details']);

          if (__TIME_METERING){
            $xmlResponse->createTag("_TIMER",  array(), "Order Details decripting ".$timer2->end(), $orderNode);
          }
          //$xmlResponse->createTag("_CCDATA",  array(), $oInfo['details'], $orderNode, __ENCODE_RESPONSE);
          //$store_cvv2 is returned as 1 if cvv code is being stored in database
          //$xmlResponse->createTag("storecvv2",  array(), $store_cvv2, $billNode);
					/** 
					  $card[index] when index is 
					  1 - Cardholder's name
					  2 - Card Type
					  3 - Card Number
					  4 - Exp Date
					  6 - CVV2
					  ---Advanced info---
					  9 - Reason
					  11 - Transaction ID
					  13 - AVS info
					  15 - CVV info
					  
					*/
										
          //if( preg_match("/^Customer notes:(.*)Cardholder\'s name:(.*)Card type:(.*)Card number:(.*)Exp.(.*)date:(.*?)(CVV2:(.*?))?(--- Advanced info ---(.*))?$/is", $oInfo['details'],$card))
		  // $xmlResponse->createTag("_DETAILS",     array(), $oInfo['details'],       $orderNode);
		  
					if( preg_match("/^Customer notes:\s*Cardholder\'s name:(.*)Card type:(.*)Card number:(.*?)Exp.\s*?date:\s*(\d*)\s*(CVV2:(.*?))?(--- Advanced info ---\s*(Reason:([^;]*?);)?\s*(Transaction ID:\s*(\d*))?\s*(AVS info:(.*?))?\s*(CVV info:\s*(.*))?)?$/is", $oInfo['details'],$card))
          {
          	//X-cart version 4.0.17 stores in this format
						//Customer notes: Please ship as soon as possible
						//Cardholder's name: David Nickell
						//Card type: VISA
						//Card number: 4661421930000000
						//Exp. date: 0408
						//CVV2: 778
						//--- Advanced info ---
						//Reason: Approved:  Approval Code: 926540; Transaction ID: 1352262930
						//AVS info: Address (Street) and 5 digit ZIP match
						//CVV info: Match

            $creditCard = $xmlResponse->createTag("CreditCard",  array(), '',   $billNode);
            $xmlResponse->createTag("CreditCardType",     array(), $card[3],       $creditCard, __ENCODE_RESPONSE);
            $xmlResponse->createTag("CreditCardCharge",   array(), $oInfo['total'],  $creditCard, __ENCODE_RESPONSE);
            $xmlResponse->createTag("ExpirationDate",     array(), $card[6],    $creditCard, __ENCODE_RESPONSE);
            $xmlResponse->createTag("CreditCardName",     array(), $card[2],       $creditCard, __ENCODE_RESPONSE);
            $xmlResponse->createTag("CreditCardNumber",   array(), $card[4],    $creditCard, __ENCODE_RESPONSE);
            $xmlResponse->createTag("CVV2",   array(), $card[8],    $creditCard, __ENCODE_RESPONSE);
						//$xmlResponse->createTag("TransactionID",     array(), $card[11],    $creditCard);
		  			$xmlResponse->createTag("AuthDetails",     array(), $oInfo['details'],       $creditCard, __ENCODE_RESPONSE);

            $oInfo['payment_method'] = $card[3];
          } elseif ( preg_match("/^\{CardOwner\}:(.*)\{CardType\}:(.*)\{CardNumber\}:(.*)\{ExpDate\}:(.*?)(CVV2:(.*?))?(--- Advanced info ---(.*))?$/is", $oInfo['details'],$card)) {
          	          	
          		//X-cart version 4.1.3 stores in this format...
							//{CardOwner}: Brian Boyd
							//{CardType}: VISA
							//{CardNumber}: 498882444455555
							//{ExpDate}: 1109
							//CVV2: 511
							//--- Advanced info ---
							//Reason: Approved:
							//AVS info: Address: Match & 5 Digit Zip: Match
							//CVV info: 3 digit(s) / Match
            $creditCard = $xmlResponse->createTag("CreditCard",  array(), '',   $billNode);
            $xmlResponse->createTag("CreditCardType",     array(), $card[2],       $creditCard, __ENCODE_RESPONSE);
            $xmlResponse->createTag("CreditCardCharge",   array(), $oInfo['total'],  $creditCard, __ENCODE_RESPONSE);
            $xmlResponse->createTag("ExpirationDate",     array(), $card[4],    $creditCard, __ENCODE_RESPONSE);
            $xmlResponse->createTag("CreditCardName",     array(), $card[1],       $creditCard, __ENCODE_RESPONSE);
            $xmlResponse->createTag("CreditCardNumber",   array(), $card[3],    $creditCard, __ENCODE_RESPONSE);
            $xmlResponse->createTag("CVV2",   array(), $card[6],    $creditCard, __ENCODE_RESPONSE);
		  			$xmlResponse->createTag("AuthDetails",     array(), $oInfo['details'],       $creditCard, __ENCODE_RESPONSE);
            $oInfo['payment_method'] = $card[2];

          } elseif ( preg_match("/^PO Number: (.*)Company name:(.*)Name of purchaser:(.*)Position:(.*)$/is", $oInfo['details'], $details)) {
            $oInfo['PONumber'] = $details[1];
          }
        }
        //$xmlResponse->createTag("Comment",  array(), $card[1]." ".$oInfo['customer_notes'],      $orderNode, __ENCODE_RESPONSE);
        $xmlResponse->createTag("Comment",  array(), $oInfo['customer_notes'],      $orderNode, __ENCODE_RESPONSE);

        // Orders/Bill info
        $xmlResponse->createTag("PayMethod",array(), $oInfo['payment_method'],   $billNode, __ENCODE_RESPONSE);
        //-- enable this line to download PONumber $xmlResponse->createTag("PONumber",array(), $oInfo['po_number'],   $billNode, __ENCODE_RESPONSE);

        //MJ - 02-05-2007
        //$xmlResponse->createTag("FirstName",array(), strtok($oInfo['b_firstname'], " "),   $billNode, __ENCODE_RESPONSE);
        //$xmlResponse->createTag("LastName",array(), strtok($oInfo['b_lastname'], " "),   $billNode, __ENCODE_RESPONSE);
        //$xmlResponse->createTag("FirstName",array(), $oInfo['b_firstname'],   $billNode, __ENCODE_RESPONSE);
        //$xmlResponse->createTag("LastName",array(), $oInfo['b_lastname'],   $billNode, __ENCODE_RESPONSE);
      	//MJ - 02-05-2007  END

        if($oInfo['b_firstname'] == "") {
	        $xmlResponse->createTag("FirstName",array(), $oInfo['firstname'],   $billNode, __ENCODE_RESPONSE);
        } else {
	        $xmlResponse->createTag("FirstName",array(), $oInfo['b_firstname'],   $billNode, __ENCODE_RESPONSE);
      	}
        
        if($oInfo['b_lastname'] == "") {
	        $xmlResponse->createTag("LastName",array(), $oInfo['lastname'],   $billNode, __ENCODE_RESPONSE);
        } else {
	        $xmlResponse->createTag("LastName",array(), $oInfo['b_lastname'],   $billNode, __ENCODE_RESPONSE);
      	}

        $xmlResponse->createTag("CompanyName",array(), $oInfo['company'],   $billNode, __ENCODE_RESPONSE);

        $addr_arr =  split("\n",$oInfo['b_address']);
        $addr_line1 = $addr_arr[0];
        $addr_line2 = $addr_arr[1];

        $xmlResponse->createTag("Address1", array(), $addr_line1,   $billNode, __ENCODE_RESPONSE);
        $xmlResponse->createTag("Address2", array(), $addr_line2,   $billNode, __ENCODE_RESPONSE);
        $xmlResponse->createTag("City",     array(), $oInfo['b_city'],      $billNode, __ENCODE_RESPONSE);
        $xmlResponse->createTag("State",    array(), $oInfo['b_state'],     $billNode, __ENCODE_RESPONSE);
        $xmlResponse->createTag("Zip",      array(), $oInfo['b_zipcode'],  $billNode, __ENCODE_RESPONSE);
        $xmlResponse->createTag("Country",  array(), $oInfo['b_country'],   $billNode, __ENCODE_RESPONSE);
        $xmlResponse->createTag("Email",    array(), $oInfo['email'],     $billNode, __ENCODE_RESPONSE);
        $xmlResponse->createTag("Phone",    array(), $oInfo['phone']?$oInfo['phone']:$extra['additional_fields'][0]['value'],     $billNode, __ENCODE_RESPONSE);
        $xmlResponse->createTag("PONumber", array(), $oInfo['PONumber'],  $billNode, __ENCODE_RESPONSE);

        // Orders/Ship info
        $ship_method = $oInfo['ship_title'];

        $xmlResponse->createTag("ShipMethod",array(), $ship_method,   $shipNode, __ENCODE_RESPONSE);
        if($oInfo['tracking'] == "") {
	        $xmlResponse->createTag("ShipStatus",array(), 'New',   $shipNode);
        } else {
	        $xmlResponse->createTag("ShipStatus",array(), 'Shipped',   $shipNode);
      	}       
 				$xmlResponse->createTag("Tracking",array(), $oInfo['tracking'],   $shipNode);
       
        if($oInfo['s_firstname'] == "") {
	        $xmlResponse->createTag("FirstName",array(), $oInfo['firstname'],   $shipNode, __ENCODE_RESPONSE);
        } else {
	        $xmlResponse->createTag("FirstName",array(), $oInfo['s_firstname'],   $shipNode, __ENCODE_RESPONSE);
      	}
        
        if($oInfo['s_lastname'] == "") {
	        $xmlResponse->createTag("LastName",array(), $oInfo['lastname'],   $shipNode, __ENCODE_RESPONSE);
        } else {
	        $xmlResponse->createTag("LastName",array(), $oInfo['s_lastname'],   $shipNode, __ENCODE_RESPONSE);
      	}
        
       	//$xmlResponse->createTag("FirstName",array(), $oInfo['s_firstname'],   $shipNode, __ENCODE_RESPONSE);
        //$xmlResponse->createTag("LastName", array(), $oInfo['s_lastname'],   $shipNode, __ENCODE_RESPONSE);

        $xmlResponse->createTag("CompanyName",array(), $oInfo['company'],   $shipNode, __ENCODE_RESPONSE);
        $addr_line1 ='';
        $addr_line2 ='';
        $addr_arr =  split("\n",$oInfo['s_address']);
        $addr_line1 = $addr_arr[0];
        $addr_line2 = $addr_arr[1];
        $xmlResponse->createTag("Address1", array(), $addr_line1,   $shipNode, __ENCODE_RESPONSE);
        $xmlResponse->createTag("Address2", array(), $addr_line2,   $shipNode, __ENCODE_RESPONSE);

        $xmlResponse->createTag("City",     array(), $oInfo['s_city'],     $shipNode, __ENCODE_RESPONSE);
        $xmlResponse->createTag("State",    array(), $oInfo['s_state'],    $shipNode, __ENCODE_RESPONSE);
        $xmlResponse->createTag("Zip",      array(), $oInfo['s_zipcode'], $shipNode, __ENCODE_RESPONSE);
        $xmlResponse->createTag("Country",  array(), $oInfo['s_country'],  $shipNode, __ENCODE_RESPONSE);
        $xmlResponse->createTag("Email",    array(), $oInfo['email'],    $shipNode, __ENCODE_RESPONSE);
        $xmlResponse->createTag("Phone",    array(), $oInfo['phone']?$oInfo['phone']:$extra['additional_fields'][1]['value'],    $shipNode, __ENCODE_RESPONSE);

        // get items of order
        // --------------------

        $items_query_raw = "SELECT o.*, o.Productcode ord_prod_sku, p.* FROM ".$sql_tbl[order_details]
           ." o LEFT JOIN ".$sql_tbl[products]." p ON p.productid = o.productid WHERE o.orderid = '".$oInfo['orderid']."'";

        // $xmlResponse->createTag("_ItemsQuery", array(), $items_query_raw, $itemsNode);
        $items_query = db_query($items_query_raw);

        while ($iInfo = db_fetch_array($items_query)) {
          $iInfo = parseSpecCharsA($iInfo);
          $itemNode = $xmlResponse->createTag("Item",    array(), '',    $itemsNode);

          //$xmlResponse->createTag("ItemId",       array(), $iInfo['productid'], $itemNode);
          //$xmlResponse->createTag("ItemCode",       array(), $iInfo['productcode'], $itemNode);
          $xmlResponse->createTag("ItemCode",       array(), $iInfo['ord_prod_sku'], $itemNode, __ENCODE_RESPONSE);
        	//MJ 042409
        	$iCode = $iInfo['ord_prod_sku'];
					$variantWeight = 0.0;
					$variantWeightQuerySQL = "SELECT weight FROM ".$sql_tbl[variants]." WHERE productcode='".$iCode."'";
					$variantWeightQuery = db_query($variantWeightQuerySQL);
					while ($iVariantInfo = db_fetch_array($variantWeightQuery)) {
						$variantWeight = $iVariantInfo['weight'];
					}
        	//MJ 042409

          $xmlResponse->createTag("ItemDescription",array(), $iInfo['product'],      $itemNode, __ENCODE_RESPONSE);
          $xmlResponse->createTag("Quantity",       array(), $iInfo['amount'],  $itemNode);
          $xmlResponse->createTag("UnitPrice",      array(), $iInfo['price'],        $itemNode);
          //MJ 042409
          //$xmlResponse->createTag("ItemUnitWeight",      array(), $iInfo['weight'],  $itemNode);
          $iWeight = 0.0;
          if ($variantWeight > 0) {
          	$iWeight = $variantWeight;
          } else {
          	$iWeight = $iInfo['weight'];
          }
          $xmlResponse->createTag("ItemUnitWeight",      array(), $iWeight,  $itemNode);
					//MJ 042409

          $custom_query_raw = "SELECT v.*,f.field FROM ".$sql_tbl[extra_field_values]." v LEFT JOIN ".$sql_tbl[extra_fields]." f ON v.fieldid = f.fieldid WHERE v.productid = '".$iInfo['productid']."' AND f.active='Y' ORDER BY v.fieldid LIMIT 5";

          // $xmlResponse->createTag("_AttrsQuery", array(), $custom_query_raw, $itemNode);

          $custom_query = db_query($custom_query_raw);

          $c = 1;

          while ($cInfo = db_fetch_array($custom_query)) {
                $cInfo = parseSpecCharsA($cInfo);
                $xmlResponse->createTag("CustomField".$c,      array("field" => $cInfo['field']), $cInfo['value'], $itemNode, __ENCODE_RESPONSE);
                $c++;
          }
          for($l=$c;$l<6;$l++)
          {
            $xmlResponse->createTag("CustomField".$l,      array(), "", $itemNode, __ENCODE_RESPONSE);
          }

          if ( $iInfo['product_options'] != '')
          {
              $iOptions = $xmlResponse->createTag("ItemOptions",      array(), '',        $itemNode);
              $options = split("\n",$iInfo['product_options']);
              foreach($options as $option)
              {
                  preg_match('/^(.*):(.*)$/is',$option,$opt_res);
                  $xmlResponse->createTag("ItemOption",      array("Value"=>$opt_res[2],"Name"=>$opt_res[1]), "",        $iOptions, __ENCODE_RESPONSE);
              }
          }

        } // end items

        // $discount = (float)$oInfo['discount']+(float)$oInfo['coupon_discount'];
        $discount = $oInfo['full_discount'];
        $coupon_name = $oInfo['coupon'];

        $xmlResponse->createTag("Discount", !empty($coupon_name)?array('Name'=>$coupon_name):array(), $discount, $chargesNode);
        // $xmlResponse->createTag("GiftCertificate", array(), $discountGC, $chargesNode);

        $xmlResponse->createTag("Tax",      array(), $oInfo['tax'],				$chargesNode);
        $xmlResponse->createTag("Shipping", array(), $oInfo['shipping_cost'],   $chargesNode);
        $xmlResponse->createTag("Total",    array(), $oInfo['total'],			$chargesNode);

     //   $list_orders[]=$oInfo['orderid'];

   	  }   //orders
        //**********************
        //****  FOR RMA
        //**********************
        if ($fl_module_RMA ){ //is module RMA a active

			$str_date_filter_ret = " AND to_days(Now()) - TO_DAYS(FROM_UNIXTIME(r.date)) <= '".QB_NUMBER_OF_DAYS_RETURN."'";
			//	$str_date_filter_ret ="";
			if (!empty($sql_tbl[returns_items])) {

				$sqlquery = 	"SELECT r.itemid, o.orderid, r.returnid, r.date "
						." FROM $sql_tbl[returns] r, $sql_tbl[returns_items] ri, $sql_tbl[orders] o, $sql_tbl[order_details] od"
						." WHERE r.returnid = ri.returnid "
						." AND ri.itemid = od.itemid "
						." AND od.orderid=o.orderid "
						." ". QB_RETURNS_STATUS_LIST." "
						." ".QB_ORDERS_DOWNLOAD_EXCL_LIST
						." ".$str_date_filter_ret
						." GROUP BY o.orderid";

				//$xmlResponse->createTag("_OrdersQueryReturn1", array(), $sqlquery, $ordersNode);

				$items_query1 = db_query($sqlquery);

				if (db_num_rows($items_query1) != 0 ){
				//$xmlResponse->createTag("_OrdersQueryReturnResult", array(), "true", $ordersNode);

					while ($return_order_Info = db_fetch_array($items_query1)){
						$return_order_Info = parseSpecCharsA($return_order_Info);

						$orders_query_raw = "
							SELECT o.discount+o.coupon_discount as full_discount,o.giftcert_discount, o.*,s.shipping as ship_title
							FROM $sql_tbl[orders] o "
								."LEFT JOIN ".$sql_tbl[shipping]." s ON s.shippingid = o.shippingid
							WHERE o.orderid =".$return_order_Info['orderid']
							." GROUP BY o.orderid
							ORDER BY o.orderid " ;

					//   $xmlResponse->createTag("_OrdersQueryReturn", array(), $orders_query_raw, $ordersNode);
						$orders_query = db_query($orders_query_raw);

						while ($oInfo = db_fetch_array($orders_query)) {
							$oInfo = parseSpecCharsA($oInfo);
							$orderNode  = $xmlResponse->createTag("Order",  array(), '', $ordersNode);
							$xmlResponse->createTag("TransactionType",  array(), "Return", $orderNode, __ENCODE_RESPONSE);

					// ob_start();
					// $_temp = unserialize($oInfo['extra']);
					// var_dump($_temp);
					// $_dump = ob_get_contents();
					// ob_end_clean();
					// $xmlResponse->createTag("OrderID",  array(), $_dump,     $orderNode);

					// Orders/Order info
							$xmlResponse->createTag("OrderID",  array(), $return_order_Info['returnid'],     $orderNode);
							$xmlResponse->createTag("OrigOrderID",  array(), $oInfo['orderid'],     $orderNode);
							$xmlResponse->createTag("Date",    array(), date("Y-m-d",$return_order_Info['date']), $orderNode); //date
						   // $xmlResponse->createTag("Date",     array(), date("Y-m-d",$oInfo['date']), $orderNode); //date
							$xmlResponse->createTag("Time",     array(), date("H:i:s",$oInfo['date']), $orderNode); //time
							$xmlResponse->createTag("StoreId",  array(), STORE_NAME_ID,        $orderNode, __ENCODE_RESPONSE);
							$xmlResponse->createTag("StoreName",array(), STORE_NAME,           $orderNode, __ENCODE_RESPONSE);
							$xmlResponse->createTag("Currency", array(), "USD",           $orderNode, __ENCODE_RESPONSE);
						//  $xmlResponse->createTag("TimeZone", array(), 'PST',                 $orderNode);

							$xmlResponse->createTag("Comment",  array(), $oInfo['customer_notes'],      $orderNode, __ENCODE_RESPONSE);

							$itemsNode  = $xmlResponse->createTag("Items",  array(), '', $orderNode);
							$chargesNode  = $xmlResponse->createTag("Charges", array(), '', $orderNode);
							$extra = unserialize($oInfo['extra']);


							$billNode  = $xmlResponse->createTag("Bill",    array(), '', $orderNode);
							$shipNode  = $xmlResponse->createTag("Ship",    array(), '', $orderNode);

							#  // Orders/Bill/CreditCard info

							$shipto = '';
							if (!empty($oInfo['details']))        {

								$timer2 = new timerClass();
								$timer2->start();

								$oInfo['details'] = text_decrypt($oInfo['details']);

								if (__TIME_METERING){
									$xmlResponse->createTag("_TIMER",  array(), "Order Details decripting ".$timer2->end(), $orderNode);
								}
							  //$xmlResponse->createTag("_CCDATA",  array(), $oInfo['details'], $orderNode, __ENCODE_RESPONSE);
							  //$store_cvv2 is returned as 1 if cvv code is being stored in database
							  //$xmlResponse->createTag("storecvv2",  array(), $store_cvv2, $billNode);

							   if( preg_match("/^Customer notes:(.*)Cardholder\'s name:(.*)Card type:(.*)Card number:(.*)Exp.(.*)date:(.*?)(CVV2:(.*?))?(--- Advanced info ---(.*))?$/is", $oInfo['details'],$card)){
							  //if( preg_match('/^Customer notes:(.*)Cardholder\'s name:(.*)Card type:(.*)Card number:(.*)Exp.(.*)date:(.*)CVV2:(.*)$/is',$oInfo['details'],$card))
								//X-cart version 4.0.17 stores in this format
											//Customer notes: Please ship as soon as possible
											//Cardholder's name: David Nick
											//Card type: VISA
											//Card number: 4661421930000000
											//Exp. date: 0408
											//CVV2: 778
											//--- Advanced info ---
											//Reason: Approved:  Approval Code: 926540; Transaction ID: 1352262930
											//AVS info: Address (Street) and 5 digit ZIP match
											//CVV info: Match

								$creditCard = $xmlResponse->createTag("CreditCard",  array(), '',   $billNode);

								$xmlResponse->createTag("CreditCardType",     array(), $card[3],       $creditCard, __ENCODE_RESPONSE);
								$xmlResponse->createTag("CreditCardCharge",   array(), $oInfo['total'],  $creditCard, __ENCODE_RESPONSE);
								$xmlResponse->createTag("ExpirationDate",     array(), $card[6],    $creditCard, __ENCODE_RESPONSE);
								$xmlResponse->createTag("CreditCardName",     array(), $card[2],       $creditCard, __ENCODE_RESPONSE);
								$xmlResponse->createTag("CreditCardNumber",   array(), $card[4],    $creditCard, __ENCODE_RESPONSE);
								$xmlResponse->createTag("CVV2",   array(), $card[8],    $creditCard, __ENCODE_RESPONSE);

								$oInfo['payment_method'] = $card[3];
							  } elseif ( preg_match("/^\{CardOwner\}:(.*)\{CardType\}:(.*)\{CardNumber\}:(.*)\{ExpDate\}:(.*?)(CVV2:(.*?))?(--- Advanced info ---(.*))?$/is", $oInfo['details'],$card)) {
									//X-cart version 4.1.3 stores in this format...
												//{CardOwner}: Brian Beauchamp
												//{CardType}: VISA
												//{CardNumber}: 498882444455555
												//{ExpDate}: 1109
												//CVV2: 511
												//--- Advanced info ---
												//Reason: Approved:
												//AVS info: Address: Match & 5 Digit Zip: Match
												//CVV info: 3 digit(s) / Match
								$creditCard = $xmlResponse->createTag("CreditCard",  array(), '',   $billNode);
								$xmlResponse->createTag("CreditCardType",     array(), $card[2],       $creditCard, __ENCODE_RESPONSE);
								$xmlResponse->createTag("CreditCardCharge",   array(), $oInfo['total'],  $creditCard, __ENCODE_RESPONSE);
								$xmlResponse->createTag("ExpirationDate",     array(), $card[4],    $creditCard, __ENCODE_RESPONSE);
								$xmlResponse->createTag("CreditCardName",     array(), $card[1],       $creditCard, __ENCODE_RESPONSE);
								$xmlResponse->createTag("CreditCardNumber",   array(), $card[3],    $creditCard, __ENCODE_RESPONSE);
								$xmlResponse->createTag("CVV2",   array(), $card[6],    $creditCard, __ENCODE_RESPONSE);

								$oInfo['payment_method'] = $card[2];

							  } elseif ( preg_match("/^PO Number: (.*)Company name:(.*)Name of purchaser:(.*)Position:(.*)$/is", $oInfo['details'], $details)) {
								$oInfo['PONumber'] = $details[1];
							  }
							}

							//$xmlResponse->createTag("Comment",  array(), $card[1]." ".$oInfo['customer_notes'],      $orderNode, __ENCODE_RESPONSE);
							$xmlResponse->createTag("Comment",  array(), $oInfo['customer_notes'],      $orderNode, __ENCODE_RESPONSE);

							// Orders/Bill info
							$xmlResponse->createTag("PayMethod",array(), $oInfo['payment_method'],   $billNode, __ENCODE_RESPONSE);

							//MJ - 02-05-2007
							//$xmlResponse->createTag("FirstName",array(), strtok($oInfo['b_firstname'], " "),   $billNode, __ENCODE_RESPONSE);
							//$xmlResponse->createTag("LastName",array(), strtok($oInfo['b_lastname'], " "),   $billNode, __ENCODE_RESPONSE);
							$xmlResponse->createTag("FirstName",array(), $oInfo['b_firstname'],   $billNode, __ENCODE_RESPONSE);
							$xmlResponse->createTag("LastName",array(), $oInfo['b_lastname'],   $billNode, __ENCODE_RESPONSE);
							//MJ - 02-05-2007  END
							$xmlResponse->createTag("CompanyName",array(), $oInfo['company'],   $billNode, __ENCODE_RESPONSE);

							$addr_arr =  split("\n",$oInfo['b_address']);
							$addr_line1 = $addr_arr[0];
							$addr_line2 = $addr_arr[1];

							$xmlResponse->createTag("Address1", array(), $addr_line1,   $billNode, __ENCODE_RESPONSE);
							$xmlResponse->createTag("Address2", array(), $addr_line2,   $billNode, __ENCODE_RESPONSE);
							$xmlResponse->createTag("City",     array(), $oInfo['b_city'],      $billNode, __ENCODE_RESPONSE);
							$xmlResponse->createTag("State",    array(), $oInfo['b_state'],     $billNode, __ENCODE_RESPONSE);
							$xmlResponse->createTag("Zip",      array(), $oInfo['b_zipcode'],  $billNode, __ENCODE_RESPONSE);
							$xmlResponse->createTag("Country",  array(), $oInfo['b_country'],   $billNode, __ENCODE_RESPONSE);
							$xmlResponse->createTag("Email",    array(), $oInfo['email'],     $billNode, __ENCODE_RESPONSE);
							$xmlResponse->createTag("Phone",    array(), $oInfo['phone']?$oInfo['phone']:$extra['additional_fields'][0]['value'],     $billNode, __ENCODE_RESPONSE);
							$xmlResponse->createTag("PONumber", array(), $oInfo['PONumber'],  $billNode, __ENCODE_RESPONSE);

							// Orders/Ship info
							$ship_method = $oInfo['ship_title'];

							$xmlResponse->createTag("ShipMethod",array(), $ship_method,   $shipNode, __ENCODE_RESPONSE);
							//$xmlResponse->createTag("Tracking",array(), $oInfo['Tracking'],   $shipNode, __ENCODE_RESPONSE);

							$xmlResponse->createTag("FirstName",array(), $oInfo['s_firstname'],   $shipNode, __ENCODE_RESPONSE);
							$xmlResponse->createTag("LastName", array(), $oInfo['s_lastname'],   $shipNode, __ENCODE_RESPONSE);

							$xmlResponse->createTag("CompanyName",array(), $oInfo['company'],   $shipNode, __ENCODE_RESPONSE);

							$addr_line1 ='';
							$addr_line2 ='';
							$addr_arr =  split("\n",$oInfo['s_address']);
							$addr_line1 = $addr_arr[0];
							$addr_line2 = $addr_arr[1];
							$xmlResponse->createTag("Address1", array(), $addr_line1,   $shipNode, __ENCODE_RESPONSE);
							$xmlResponse->createTag("Address2", array(), $addr_line2,   $shipNode, __ENCODE_RESPONSE);

							$xmlResponse->createTag("City",     array(), $oInfo['s_city'],     $shipNode, __ENCODE_RESPONSE);
							$xmlResponse->createTag("State",    array(), $oInfo['s_state'],    $shipNode, __ENCODE_RESPONSE);
							$xmlResponse->createTag("Zip",      array(), $oInfo['s_zipcode'], $shipNode, __ENCODE_RESPONSE);
							$xmlResponse->createTag("Country",  array(), $oInfo['s_country'],  $shipNode, __ENCODE_RESPONSE);
							$xmlResponse->createTag("Email",    array(), $oInfo['email'],    $shipNode, __ENCODE_RESPONSE);
							$xmlResponse->createTag("Phone",    array(), $oInfo['phone']?$oInfo['phone']:$extra['additional_fields'][1]['value'],    $shipNode, __ENCODE_RESPONSE);

					// get items of order
					// --------------------

					  //$xmlResponse->createTag("ItemId",       array(), $iInfo['productid'], $itemNode);
					  //$xmlResponse->createTag("ItemCode",       array(), $iInfo['productcode'], $itemNode);
								$xmlResponse->createTag("ItemCode",       array(), $iInfo['ord_prod_sku'], $itemNode, __ENCODE_RESPONSE);

								$items_query_raw = "SELECT ri.amount as ri_amount,"
														." ri.price as ri_price, "
														."o.Productcode ord_prod_sku, p.product "
									." FROM ".$sql_tbl[order_details]." o ,"
											." $sql_tbl[returns] r,"
											." $sql_tbl[returns_items] ri,"
											." $sql_tbl[products] p "
									." WHERE 	o.orderid = '".$return_order_Info['orderid']."'"
												." AND r.returnid = ri.returnid
												   AND p.productid = o.productid
												   AND ri.itemid = o.itemid
												   AND r.returnid ='".$return_order_Info['returnid']."'";

					// $xmlResponse->createTag("_ItemsQuery", array(), $items_query_raw, $itemsNode);

								$items_query2 = db_query($items_query_raw);

								while ($iInfo = db_fetch_array($items_query2)) {
									$iInfo = parseSpecCharsA($iInfo);
									$itemNode = $xmlResponse->createTag("Item",    array(), '',    $itemsNode);

					  //$xmlResponse->createTag("ItemId",       array(), $iInfo['productid'], $itemNode);
					  //$xmlResponse->createTag("ItemCode",       array(), $iInfo['productcode'], $itemNode);
									$xmlResponse->createTag("ItemCode",       array(), $iInfo['ord_prod_sku'], $itemNode, __ENCODE_RESPONSE);

									$xmlResponse->createTag("ItemDescription",array(), $iInfo['product'],      $itemNode, __ENCODE_RESPONSE);
									$xmlResponse->createTag("Quantity",       array(), $iInfo['ri_amount'],  $itemNode);
									$xmlResponse->createTag("UnitPrice",      array(), $iInfo['ri_price'],        $itemNode);
	//		          $xmlResponse->createTag("ItemUnitWeight",      array(), $iInfo['weight'],  $itemNode);

								} // end items

							$sqlquery = "Select Sum(ri.tax * ri.amount) as tax,
												Sum(ri.ship_cost * ri.amount) as shipping,
												Sum((ri.ship_cost+ri.tax+ri.price) * ri.amount) as total
										from $sql_tbl[returns_items] ri
										where ri.returnid = ".$return_order_Info['returnid'];

							//$xmlResponse->createTag("_OrdersQueryReturn", array(), $sqlquery, $ordersNode);

							$Tax_query = db_query($sqlquery);

							if (db_num_rows($Tax_query) != 0 ){
								$tax_return_Info = db_fetch_array($Tax_query);
								$$tax_return_Info = parseSpecCharsA($tax_return_Info);
								$xmlResponse->createTag("Tax",      array(), $tax_return_Info['tax'],				$chargesNode);
								$xmlResponse->createTag("Shipping", array(), $tax_return_Info['shipping'],   $chargesNode);
								$xmlResponse->createTag("Total",    array(), $tax_return_Info['total'],			$chargesNode);
							}else{
								$xmlResponse->createTag("Tax",      array(), -0,	$chargesNode);
								$xmlResponse->createTag("Shipping", array(), -0,	$chargesNode);
								$xmlResponse->createTag("Total",    array(), -0,	$chargesNode);
							}
						} //end $return_order_Info
					}
				}
			}	
			
        } //end  RMA

        if (__TIME_METERING){
          $xmlResponse->createTag("_TIMER",  array(), "total time for getting order ".$timer1->end(), $orderNode);
        }
        // break;

      if (__TIME_METERING){
        $xmlResponse->createTag("_TIMER2",  array(), "orders composed to XML ".$timer->end(), $ordersNode);
      }

    } break;

    //***************************************************
    //
    //      update  Orders Service
    //
    //***************************************************

    case 'UPDATEORDERS' : {
      $ordersTag = $xmlRequest->getChildByName(0, "ORDERS");
      $xmlRequest->getTag($ordersTag, $_tagName, $_tagAttributes, $_tagContents, $_tagTags);
      if (count($_tagTags) == 0) $no_orders = true; else $no_orders = false;
      $xmlResponse->createTag("StatusCode", array(), $no_orders?"1000":"0", $envelope);
      $xmlResponse->createTag("StatusMessage", array(), $no_orders?"No Orders returned":"All Ok", $envelope);
      if ($no_orders){
        print($xmlResponse->generate()); exit;
      }

      $ordersNode = $xmlResponse->createTag("Orders", array(), '', $root);
      foreach($_tagTags as $k=>$v){
        $xmlRequest->getTag($v, $_tagName, $_tagAttributes, $_tagContents, $_orderTags);
        $orderNode = $xmlResponse->createTag("Order",  array(), '',     $ordersNode);

        foreach($_orderTags as $k1=>$v1){
          $xmlRequest->getTag($v1, $_tagName, $_tagAttributes, $_tagContents, $_tempTags);
          $order[strtoupper($_tagName)] = $_tagContents;
          if (strtoupper($_tagName)!='LOCALSTATUS')
            $xmlResponse->createTag($_tagName,  array(), $_tagContents,     $orderNode);
        }

        $query = db_query("SELECT count(*) cnt FROM ".$sql_tbl[orders]." WHERE orderid = '".$order['HOSTORDERID']."'");
        $row = db_fetch_array($query);

        $result = 'Success';

        if ($row['cnt']==0) $result = 'Order not found';


        $xmlResponse->createTag('HostStatus',  array(), $result, $orderNode);
      }
    } break;

    //***************************************************
    //
    //      update  Orders Shipping Status Service
    //
    //***************************************************

    case 'UPDATEORDERSSHIPPINGSTATUS' : {
      $ordersTag = $xmlRequest->getChildByName(0, "ORDERS");
      $xmlRequest->getTag($ordersTag, $_tagName, $_tagAttributes, $_tagContents, $_tagTags);
      if (count($_tagTags) == 0) $no_orders = true; else $no_orders = false;
      $xmlResponse->createTag("StatusCode", array(), $no_orders?"1000":"0", $envelope);
      $xmlResponse->createTag("StatusMessage", array(), $no_orders?"No Orders returned":"All Ok", $envelope);
      if ($no_orders){
        print($xmlResponse->generate()); exit;
      }

      $ordersNode = $xmlResponse->createTag("Orders", array(), '', $root);
      foreach($_tagTags as $k=>$v){
        $xmlRequest->getTag($v, $_tagName, $_tagAttributes, $_tagContents, $_orderTags);
        $orderNode = $xmlResponse->createTag("Order",  array(), '',     $ordersNode);

        foreach($_orderTags as $k1=>$v1){
          $xmlRequest->getTag($v1, $_tagName, $_tagAttributes, $_tagContents, $_tempTags);
          $order[strtoupper($_tagName)] = $_tagContents;
          if (strtoupper($_tagName)=='HOSTORDERID')
            $xmlResponse->createTag($_tagName,  array(), $_tagContents,     $orderNode);
          if (strtoupper($_tagName)=='LOCALORDERID')
            $xmlResponse->createTag($_tagName,  array(), $_tagContents,     $orderNode);
        }

        $query = db_query("SELECT count(*) cnt FROM ".$sql_tbl[orders]." WHERE orderid = '".$order['HOSTORDERID']."'");
        $row = db_fetch_array($query);

        $result = 'Success';

        if ($row['cnt']==0) $result = 'Order not found';
        else {
          $info = "\nOrder shipped on ".$order['SHIPPEDON']." via ".$order['SHIPPEDVIA']." using ".$order['SERVICEUSED']." service\n";
          $updateQuery = "
            UPDATE " . $sql_tbl[orders] . "
            SET
              notes = CONCAT(notes, '$info'),
              status = 'C',
              tracking = '".$order['TRACKINGNUMBER']."'
            WHERE orderid = '".$order['HOSTORDERID']."'";
          if(!db_query($updateQuery)) $result = 'Failed';

					func_complete_order($order['HOSTORDERID']);			
        }

        $xmlResponse->createTag('HostStatus',  array(), $result, $orderNode);
      }

    } break;  // end of update Orders Shipping Status Service

    //***************************************************
    //
    //      update  Inventory Service
    //         26.10.2007 15:19
    //***************************************************

	case 'UPDATEINVENTORY' : {

        $addProductsTag = $xmlRequest->getChildByName(0, "ADDPRODUCTS");
        $xmlRequest->getTag($addProductsTag, $_tagName, $_tagAttributes, $addProducts, $_orderTags);

        $updDescrTag = $xmlRequest->getChildByName(0, "UPDATEDESCRIPTION");
        $xmlRequest->getTag($updDescrTag, $_tagName, $_tagAttributes, $updDescr, $_orderTags);

        $updPriceTag  = $xmlRequest->getChildByName(0, "UPDATEPRICE");
        $xmlRequest->getTag($updPriceTag, $_tagName, $_tagAttributes, $updPrice, $_orderTags);

        $updInvTag      = $xmlRequest->getChildByName(0, "UPDATEINVENTORY");
        $xmlRequest->getTag($updInvTag, $_tagName, $_tagAttributes, $updInv, $_orderTags);

        $InvListTag      = $xmlRequest->getChildByName(0, "INVENTORYLIST");
        $xmlRequest->getTag($InvListTag, $_tagName, $_tagAttributes, $InvList, $_orderTags);

        $InvListNumberTag = $xmlRequest->getChildByName(0, "INVENTORYLISTBATCHNUMBER");
        $xmlRequest->getTag($InvListNumberTag, $_tagName, $_tagAttributes, $InvListNumber, $_orderTags);

        $InvListSizeTag      = $xmlRequest->getChildByName(0, "INVENTORYLISTBATCHSIZE");
        $xmlRequest->getTag($InvListSizeTag, $_tagName, $_tagAttributes, $InvListSize, $_orderTags);


        $itemsTag = $xmlRequest->getChildByName(0, "ITEMS");
        $xmlRequest->getTag($itemsTag, $_tagName, $_tagAttributes, $_tagContents, $_tagTags);

        if (isset($request_id)) $xmlResponse->createTag("RequestID", array(), $request_id, $envelope);
        $xmlResponse->createTag("StoreID",   array(), STORE_NAME, $envelope, __ENCODE_RESPONSE);
        $xmlResponse->createTag("StoreName", array(), STORE_NAME, $envelope, __ENCODE_RESPONSE);

        $xmlResponse->createTag("StatusCode",   array(), "0", $envelope);
        $xmlResponse->createTag("StatusMessage", array(), "ALL OK", $envelope, __ENCODE_RESPONSE);
        $xmlResponse->createTag("xcartversion", array(), XCART_VERSION, $envelope);

			// create tag Debug
		if(__MB_DEBUG){
			$MB_DebugTag = $xmlResponse->createTag("Debug", array(), '', $root);
			$xmlResponse->createTag("AddProducts",   array(), $addProducts, $MB_DebugTag, __ENCODE_RESPONSE);
		}

       // create tag ITEMS
        $items = $xmlResponse->createTag("Items", array(), '', $root);
        // greate tag AddProduct
        $xmlResponse->createTag("AddProducts",   array(), $addProducts, $root, __ENCODE_RESPONSE);

        $itemsCount = 0;
        $itemsProcessed = 0;

        //==== take sub tags in ITEMS and option field in ItemsOption tag 
        //===
        $xmlRequest->getTag($itemsTag, $_tagName, $_tagAttributes, $_tagContents, $_tagTags);

      /////////////////////////////////
      ////                          ///
      ////  foreach for all item    ///
      ////                          ///
      /////////////////////////////////
      $error_stat=0;

        foreach($_tagTags as $k=>$itemTag){

				// get item fields

	            $itemNameTag = $xmlRequest->getChildByName($itemTag,    "ITEMNAME");           $xmlRequest->getTag($itemNameTag,  $_tagName, $_tagAttributes, $itemName, $_orderTags);

	            $itemManufTag = $xmlRequest->getChildByName($itemTag,    "MANUFACTURER");           $xmlRequest->getTag($itemManufTag,  $_tagName, $_tagAttributes, $itemManufacturer, $_orderTags);

	            $itemCodeTag = $xmlRequest->getChildByName($itemTag,    "ITEMCODE");           $xmlRequest->getTag($itemCodeTag,  $_tagName, $_tagAttributes, $itemCode, $_orderTags);
	            $itemCategTag = $xmlRequest->getChildByName($itemTag,    "CATEGORY");           $xmlRequest->getTag($itemCategTag,  $_tagName, $_tagAttributes, $itemCategories, $_orderTags);
	            $itemCodeParentTag = $xmlRequest->getChildByName($itemTag,    "ITEMCODEPARENT");           $xmlRequest->getTag($itemCodeParentTag,  $_tagName, $_tagAttributes, $itemCodeParent, $_orderTags);
	            $itemDescrTag = $xmlRequest->getChildByName($itemTag,   "ITEMDESCRIPTION");    $xmlRequest->getTag($itemDescrTag, $_tagName, $_tagAttributes, $itemDescr, $_orderTags);
	            $itemPriceTag = $xmlRequest->getChildByName($itemTag,   "PRICE");              $xmlRequest->getTag($itemPriceTag, $_tagName, $_tagAttributes, $itemPrice, $_orderTags);
	            $itemStockTag = $xmlRequest->getChildByName($itemTag,   "QUANTITYINSTOCK");    $xmlRequest->getTag($itemStockTag, $_tagName, $_tagAttributes, $itemStock, $_orderTags);

	            $itemWeightTag = $xmlRequest->getChildByName($itemTag,   "UNITWEIGHT");    $xmlRequest->getTag($itemWeightTag, $_tagName, $_tagAttributes, $itemWeight, $_orderTags);

	          //////////////////////////////
	          //  get classes and option  //
	          //  $class[name]=option     //
	          //////////////////////////////
			  
	 			$xmlRequest->getTag($itemTag, $_tagName, $_tagAttributes, $_tagContents, $_optionsTags);
	 			$opt_name_array = array();
	 			$opt_value_array = array();
	 			$class = array();
	 			$dOptionCount = 0;
	 			foreach($_optionsTags as $k=>$optionTag){
	 				$xmlRequest->getTag($optionTag, $_tagName, $_tagAttributes, $_tagContents, $sub_optionsTags);
	 				if($_tagName != "ITEMOPTION") continue;
	 				$class[$_tagAttributes['NAME']]=$_tagContents;
	 				$dOptionCount = $dOptionCount + 1;
	 			}
	          /////////////////////////////////
	          // end get classes and option ///
	          /////////////////////////////////

				// XML RESPONSE
				$item = $xmlResponse->createTag("Item", array(), '', $items);
				$xmlResponse->createTag("ItemCode",   array(), $itemCode, $item, __ENCODE_RESPONSE);
				$itemName=addslashes(trim($itemName));
				$itemCodeParent=addslashes(trim($itemCodeParent));
				$itemDescr=addslashes(urldecode($itemDescr));
				$itemCode=addslashes(trim($itemCode));
				$itemDescr =addslashes(trim($itemDescr));
				$itemPrice =addslashes(trim($itemPrice ));
				$itemStock=addslashes(trim($itemStock));
				$itemWeight=addslashes(trim($itemWeight));
				if ($itemWeight == "") $itemWeight = "0";
				$itemCategories= addslashes(trim($itemCategories));

				while ($addProducts){     // use while us if/// we need use break... it dont work in if(){}
						/////////////////////////////////////////////////
						//  find id for category   or create it       ///
						/////////////////////////////////////////////////
					unset($categoryid);
					$parentid=0;
					unset($categoryid_path);
					unset($category);

					if ($itemCategories){
						$itemCategories = ereg_replace('//','/',$itemCategories);
						$itemCategories = ereg_replace('^/','',$itemCategories);
						$itemCategories = ereg_replace('/$','',$itemCategories);

						$categories = explode("/", $itemCategories);

						foreach($categories as $cate){
							$query = db_query("SELECT * FROM ".$sql_tbl[categories]." WHERE category = '".$cate."' and parentid= '".$parentid."'");
							if (db_num_rows($query)==0){
								$query_max = db_query("select MAX(categoryid) as '".categoryid."' from ".$sql_tbl[categories]."");
								$row = db_fetch_array($query_max);
								$categoryid=$row['categoryid']+1;
								$categoryid_path.="/".$categoryid;
								$categoryid_path=ereg_replace("//*","/",$categoryid_path);
								$categoryid_path=ereg_replace("^/*","",$categoryid_path);
								
								
								//Ganesh 12June2012
								if ( XCART_VERSION >= 4.5) {
										$query_answer = db_query("insert into ".$sql_tbl[categories]." (categoryid,parentid, category) values ('".$categoryid."','".$parentid."','".$cate."')");
								} else {
										$query_answer = db_query("insert into ".$sql_tbl[categories]." (categoryid,parentid,categoryid_path, category) values ('".$categoryid."','".$parentid."','".$categoryid_path."','".$cate."')");
								}
								
								if ( !$query_answer ) {$error_stat = 1;$error_massage[].="Not add to ".$sql_tbl[categories];}
								$query = db_query("SELECT * FROM ".$sql_tbl[categories]." WHERE category = '".$cate."' and parentid= '".$parentid."'");
								unset($categoryid_path);
							}else {
								unset($categoryid_path);
							}
							$row=db_fetch_array($query);
							$categoryid=$row['categoryid'];
							$parentid=$row['categoryid'];
							$categoryid_path.="/".$row['categoryid_path'];
						}
					}
					$itemCategories=$categoryid;

					/////////////////////////////////////////
					//    end         ind id for category ///
					/////////////////////////////////////////

					/////////////////////////////////////////////////////
					//  find id for manufacturer   or create it       ///
					/////////////////////////////////////////////////////
					$itemManufacturer=addslashes(urldecode($itemManufacturer));

					$query = db_query("SELECT * FROM ".$sql_tbl[manufacturers]." WHERE manufacturer = '".$itemManufacturer."'");
					if (db_num_rows($query)==0){
						// creat new
						$query_answer = db_query("insert into ".$sql_tbl[manufacturers]." (manufacturer) values ('".$itemManufacturer."')");
						if ( !$query_answer ) {$error_stat = 1;$error_massage[].="Not add to ".$sql_tbl[manufacturers];}
						$query_max = db_query("select MAX(manufacturerid) as '".manufactureid."' from ".$sql_tbl[manufacturers]."");
						$row = db_fetch_array($query_max);
						$manufactureid=$row['manufacturerid'];
					}
					else {
						$row = db_fetch_array($query);
						$manufactureid=$row['manufacturerid'];
					}
					/////////////////////////////////////////////////////////
					// end  find id for manufacturer   or create it       ///
					/////////////////////////////////////////////////////////

					// MB 21/04/2008
					//////////////////////////////////////////////////////
					//  START  Add product
					//////////////////////////////////////////////////////

					$query = db_query("SELECT * FROM ".$sql_tbl[products]." where productcode='".$itemCode."'");
					$row = db_fetch_array($query);

					if (db_num_rows($query)==0){  // Not found $itemCode
						if (empty($itemCodeParent)||$itemCodeParent==$itemCode || $dOptionCount == 0){
							//Add product $ItemCode in base PRODUCTS
							//////////////////////////////////////
							///        add new   product       ///
							//////////////////////////////////////

							$query = db_query("SELECT * FROM ".$sql_tbl[products]." where productcode='".$itemCode."'");
							$row = db_fetch_array($query);

							if (db_num_rows($query)==0){
								if(__MB_DEBUG){
									$xmlResponse->createTag("AddProductMsg1",   array(), "Add new product(empty($itemCodeParent)||$itemCodeParent==$itemCode)) ", $MB_DebugTag);
								}
								$query=db_query("select MAX(productid) as '".productid."' from ".$sql_tbl[products]."");
								$row=db_fetch_array($query);
								$iid=$row['productid']+1;
								// end modif
								
								
								//Ganesh 12June2012
								if ( XCART_VERSION >= 4.5) {
										$query_answer=db_query("insert into ".$sql_tbl[products]
																." (productid, productcode,provider, avail, forsale, weight, 
																list_price, add_date, manufacturerid)"
																." values ('".$iid."','".$itemCode."','"
																.$user_id."','".$itemStock."','N',".$itemWeight.",".$itemPrice.",'".date('U')."','".$manufactureid."')");
		
		
										$query_answer=db_query("insert into ".$sql_tbl[products_lng_en]
													      ."(productid, product, descr, fulldescr) "
														  ." values ('".$iid."','".$itemName."','".$itemDescr."','".$itemDescr."')");
								} else {
										$query_answer=db_query("insert into ".$sql_tbl[products]
																	." (productid, productcode, product, provider, avail, forsale, weight, 
																			list_price, descr, add_date, manufacturerid)"
																	." values ('".$iid."','".$itemCode."','".$itemName."','"
																	.$user_id."','".$itemStock."','N',".$itemWeight.",".$itemPrice.",'"
																	.$itemDescr."','".date('U')."','".$manufactureid."')");
									
								}

								if ( !$query_answer ) {$error_stat = 1;$error_massage[].="Not add to ".$sql_tbl[products];}
								else{
									if(__MB_DEBUG){
										$xmlResponse->createTag("AddProductLog",   array(), "Add new product:".$itemName.", SKU:".$itemCode, $MB_DebugTag);
									}
								}

								$query=db_query("select productid from ".$sql_tbl[products]." where productcode= '".$itemCode."'");
								$row=db_fetch_array($query);
								$productid=$row['productid']; // product indificator
																
								// create new classes...with atribute(value) from class[name]=value
								if (isset($class)){
									foreach($class  as $name=>$value)
									{
										// create class in xcart_classes
																														
										$query_answer=db_query("insert into ".$sql_tbl[classes]." (class, productid, classtext,  is_modifier ) values ('".$name."','".$productid."','".$name."','')");
										
										if ( !$query_answer ) {$error_stat = 1;$error_massage[].="Not add to ".$sql_tbl[classes];}
										else{
											if(__MB_DEBUG){
												$xmlResponse->createTag("AddProductLog",   array(), "Add new class:".$name.".", $MB_DebugTag);
											}
										}
										///exit;
										//get classid
										$query=db_query("select MAX(classid) as '".classid."' from ".$sql_tbl[classes]."");
										$row=db_fetch_array($query);
										// createoption for class in xcart_class_options
										$query_answer=db_query("insert into ".$sql_tbl[class_options]." (classid, option_name) values ('".$row['classid']."','".$value ."')");
										if ( !$query_answer ) {$error_stat = 1;$error_massage[].="Not add to ".$sql_tbl[class_options];}
										else{
											if(__MB_DEBUG){
												$xmlResponse->createTag("AddProductLog",   array(), "Add new option class:".$value.".", $MB_DebugTag);
											}
										}
									}
								}
								// select categories for product in xcart_products_categories
								$query_answer=db_query("insert into ".$sql_tbl[products_categories]." (categoryid, productid, main) values ('".$itemCategories."','".$productid ."','Y')");
								if ( !$query_answer ) {$error_stat = 1;$error_massage[].="Not add to ".$sql_tbl[products_categories];}
								// xcart_quick_flags (put flags if sub_products , prodcut_option)
								$query_answer=db_query("insert into ".$sql_tbl[quick_flags]." (productid,is_variants, is_product_options) values ('".$productid."','Y','Y')");
								if ( !$query_answer ) {$error_stat = 1;$error_massage[].="Not add to ".$sql_tbl[quick_flags];}
								
								//xcart_pricing  ??????????????????
								$query_answer=db_query("insert into ".$sql_tbl[pricing]." (productid,quantity, price) values ('".$productid."','1','".$itemPrice."')");
								
								if ( !$query_answer ) {$error_stat = 1;$error_massage[].="Not add to ".$sql_tbl[pricing];}
								else{
									if(__MB_DEBUG){
										$xmlResponse->createTag("AddProductLog",   array(), "Add price:".$itemPrice.".", $MB_DebugTag);
									}
								}
								
								$query = db_query("select MAX(priceid) as '".priceid."' from ".$sql_tbl[pricing]."");
								$row = db_fetch_array($query);
								$priceid=$row['priceid'];
					
						// xcart_quick_prices
						$query_answer=db_query("insert into ".$sql_tbl[quick_prices]." (productid,priceid) values ('".$productid."','".$priceid."')");
						
						if ( !$query_answer ) {$error_stat = 1;$error_massage[].="Not add to ".$sql_tbl[quick_prices];}
								//
								///////////////////////////////
								///      end  add new       ///
								///////////////////////////////
							}
						}else{  //not empty($itemCodeParent)|| not ($itemCodeParent==$itemCode)

							$query = db_query("SELECT * FROM ".$sql_tbl[products]." where productcode='".$itemCodeParent."'");
							$row = db_fetch_array($query);
							if (db_num_rows($query)==0){ //Not found  $itemCodeParent
								/////////////////////////////////////
								/// if no parent create new parent//
								/////////////////////////////////////
								if(__MB_DEBUG){
									$xmlResponse->createTag("AddProductMsg2",   array(), "Create new parent", $MB_DebugTag);
								}
								
						if ( XCART_VERSION >= 4.5) 
						{
							//Ganesh 12June2012
							
							    $sql1x = "insert into ".$sql_tbl[products]
											      ."( productcode, provider, avail, forsale, weight, list_price,  add_date, manufacturerid) "
												  ." values ('".$itemCodeParent."','".$user_id."','".$itemStock."','N',".$itemWeight.",".$itemPrice.",'".date('U')."','".$manufactureid."')";
								$query_answer=db_query($sql1x);
												  
								if(__MB_DEBUG){
									$xmlResponse->createTag("AddProductMsg2-1",   array(), $sql1x, $MB_DebugTag);
								}	  
												  
												  
                        } else {
								$query_answer=db_query("insert into ".$sql_tbl[products]
								                      ." ( productcode, product, provider, list_price, descr, add_date, manufacturerid) "
														." values ('".$itemCodeParent."','".$itemName."','".$user_id."',".$itemPrice.",'".$itemDescr."','".date('U')."','".$manufactureid."')");
                            }

								if ( !$query_answer ) {$error_stat = 1;$error_massage[].="Not add to ".$sql_tbl[products];}
								$query=db_query("select productid from ".$sql_tbl[products]." where productcode= '".$itemCodeParent."'");
								$row=db_fetch_array($query);
								$productidparent=$row['productid']; // product indificator

						    if ( XCART_VERSION < 4.5) 
						    {
								$query_answer=db_query("insert into ".$sql_tbl[products_lng]
											      ."(code, productid, product, descr, fulldescr) "
												  ." values ('en','".$productidparent."','".$itemName."','".$itemDescr."','".$itemDescr."')");
                            } 
							else 
							{
							    //Start-Ganesh <04Oct2012>
								$query_answer=db_query("insert into ".$sql_tbl[products_lng_en]
													      ."(productid, product, descr, fulldescr) "
														  ." values ('".$productidparent."','".$itemName."','".$itemDescr."','".$itemDescr."')");
							    //End-Ganesh <04Oct2012>
							}

								// select categories for product in xcart_products_categories
								$query_answer=db_query("insert into ".$sql_tbl[products_categories]." (categoryid, productid, main) values ('".$itemCategories."','".$productidparent ."','Y')");
								if ( !$query_answer ) {$error_stat = 1;$error_massage[].="Not add to ".$sql_tbl[products_categories];}
								// xcart_quick_flags (put flags if sub_products , prodcut_option)
								$query_answer=db_query("insert into ".$sql_tbl[quick_flags]." (productid,is_variants, is_product_options) values ('".$productidparent."','Y','Y')");
								if ( !$query_answer ) {$error_stat = 1;$error_massage[].="Not add to ".$sql_tbl[quick_flags];}
								//xcart_pricing  ??????????????????
								//MJ $query_answer=db_query("insert into ".$sql_tbl[pricing]." (productid,quantity, price) values ('".$productidparent."','1','')");
								$query_answer=db_query("insert into ".$sql_tbl[pricing]." (productid,quantity, price) values ('".$productidparent."','1','".$itemPrice."')");
								
								if ( !$query_answer ) {$error_stat = 1;$error_massage[].="Not add to ".$sql_tbl[pricing];}
								$query = db_query("select MAX(priceid) as '".priceid."' from ".$sql_tbl[pricing]."");
								$row = db_fetch_array($query);
								$priceid=$row['priceid'];
								// xcart_quick_prices
								$query_answer=db_query("insert into ".$sql_tbl[quick_prices]." (productid,priceid) values ('".$productidparent."','".$priceid."')");
								if ( !$query_answer ) {$error_stat = 1;$error_massage[].="Not add to ".$sql_tbl[quick_prices];}
								//
								////////////////////////////////////////
								/// en if no parent create new pwrent//
								////////////////////////////////////////
							}
							////////////////////////////////////////
							//     Add ItemCode to base Variant
							////////////////////////////////////////
							$query = db_query("SELECT * FROM ".$sql_tbl[products]." where productcode='".$itemCodeParent."'");
							$row = db_fetch_array($query);

							$productid=$row['productid'];
							// try find sub_products
							$str_query="SELECT * FROM ".$sql_tbl[variants]." v, ".$sql_tbl[products]." p  where p.productcode='".$itemCodeParent."'
											and v.productid=p.productid and v.productcode='".$itemCode."' ";
							$query=db_query($str_query);
							if (db_num_rows($query)!=0){// ERROR you try to add  product that already exist
								$xmlResponse->createTag("InventoryUpdateStatus",   array(),1, $item);
								$xmlResponse->createTag("InventoryUpdateStatusMessage",   array(), "Failed. you try to add  product that already exist.".$itemCode, $item, __ENCODE_RESPONSE);
								$error_stat=1;
								break(1);// next item
							}
							// no sub_product in bd
							// try to find a class  for this sub_product that already exists for parend
							// xcart_classes
							if (isset($class)){
								foreach ($class as $name=>$value){
									$query=db_query("select classid from ".$sql_tbl[classes]." where productid='".$productid."' and class='".$name."'");
									$row = db_fetch_array($query);
									if ($row) {
										$classid[$row['classid']]=$value;
									}
									else{ // no class
									// create class in xcart_classes and option
										$query_answer=db_query("insert into ".$sql_tbl[classes]." (class, productid, classtext, is_modifier) values ('".$name."','".$productid."','".$name."','')");
										if ( !$query_answer ) {$error_stat = 1;$error_massage[].="Not add to ".$sql_tbl[classes];}
										//get classid
										$query=db_query("select MAX(classid) as '".classid."' from ".$sql_tbl[classes]."");
										$row=db_fetch_array($query);
										// createoption for class in xcart_class_options
										$classid[$row['classid']]=$value;
									}
								}
							}
							// we get $classid[classid]=value
							// put these data into xcart_class_options and gat optionid
							
							if (isset($classid)){
								foreach($classid as $id=>$value){
									$query=db_query("select * from ".$sql_tbl[class_options]." where  classid='".$id."' and option_name='".$value ."'");
								//	$xmlResponse->createTag("classid-sql",   array(),"select * from ".$sql_tbl[class_options]." where  classid='".$id."' and option_name='".$value ."'", $item);
									if (db_num_rows($query)==0){
										$query_answer=db_query("insert into ".$sql_tbl[class_options]." (classid, option_name) values ('".$id."','".$value ."')");
										if ( !$query_answer ) {$error_stat = 1;$error_massage[].="Not add to ".$sql_tbl[class_options];}
										$query=db_query("select MAX(optionid) as '".optionid."' from ".$sql_tbl[class_options]."");
									}
									$row=db_fetch_array($query);
									$optionid[].=$row['optionid'];
									//echo $row['optionid'];
								}
							}
							// put into xcart_variants new sub_product
							$query=db_query("select MAX(variantid) as '".variantid."' from ".$sql_tbl[variants]."");
							$row=db_fetch_array($query);
							$variantid=$row['variantid'] + 1 ;
							
							
							$query_answer=db_query("insert into ".$sql_tbl[variants]." (variantid,productid,productcode, avail) values (". $variantid.",'".$productid."','".$itemCode."','".$itemStock."')");
							if ( !$query_answer ) {$error_stat = 1;$error_massage[].="Not add to ".$sql_tbl[variants];}




							// put into xcart_variant_items option for this sub_product
							if (isset($optionid)){
								foreach($optionid as $opt){
									$query_answer=db_query("insert into ".$sql_tbl[variant_items]." (optionid,variantid) values ('".$opt."','".$variantid."')");
									if ( !$query_answer ) {$error_stat = 1;$error_massage[].="Not add to ".$sql_tbl[variant_items];}
								}
							}
							unset($optionid);
							unset($classid);
							//xcart_pricing  ??????????????????
							$query_answer=db_query("insert into ".$sql_tbl[pricing]." (productid,quantity, price,variantid) values (".$productid.",1,".$itemPrice.",".$variantid.")");
							if ( !$query_answer ) {$error_stat = 1;$error_massage[].="Not add to ".$sql_tbl[pricing];}
							$query = db_query("select MAX(priceid) as '".priceid."' from ".$sql_tbl[pricing]."");
							$row = db_fetch_array($query);
							$priceid=$row['priceid'];

							// descrption update
							if ($updDescr && $updInv){
								$query_answer=db_query("update  ".$sql_tbl[products]." set descr='".$itemDescr."'  where productcode='".$itemCodeParent."'");
								if ( !$query_answer ) {$error_stat = 1;$error_massage[].="Not add to ".$sql_tbl[products];}
								if ($itemName!="") {
									$query_answer=db_query("update  ".$sql_tbl[products]." set product='".$itemName."'  where productcode='".$itemCodeParent."'");
									if ( !$query_answer ) {$error_stat = 1;$error_massage[].="Not add to ".$sql_tbl[products];}
								}
							}
							// udate stock for parent
							$sqlstr = "
								SELECT v1.productid, SUM(v2.avail) avail_sum
									FROM xcart_variants v1
									INNER JOIN xcart_variants v2 ON v1.productid = v2.productid
									WHERE v1.productcode = '".$itemCode."'
									GROUP BY v1.productid";
							$query = db_query($sqlstr);
							$row = db_fetch_array($query);
							if ($row['productid']){
								// update product avail  according sum of its variants.
								$qry = "UPDATE ".$sql_tbl[products]." SET avail='".$row['avail_sum']."' WHERE productid ='".$row['productid']."'";
								$query_answer = db_query($qry);
								if ( !$query_answer ) {$error_stat = 1;$error_massage[].="Not add to ".$sql_tbl[products];}
							}
						}  //if (empty($itemCodeParent)||$itemCodeParent==$itemCode)

					}

					// MB 21/04/2008
					//////////////////////////////////////////////////////
					//  End  Add product
					//////////////////////////////////////////////////////

					$xmlResponse->createTag("InventoryUpdateStatus",   array(),"0", $item);
					$xmlResponse->createTag("InventoryUpdateStatusMessage",   array(), "Success", $item, __ENCODE_RESPONSE);
					break(1);
				}//while ($addProducts)

				while (!$addProducts){
					if($updInv){
	              ///////////////////////////////////
	              //          update               //
	              ///////////////////////////////////

						if ($updDescr){ // descrption update
							$query_answer=db_query("update  ".$sql_tbl[products]." set descr='".$itemDescr."'  where productcode='".$itemCodeParent."'");
							if ( !$query_answer ) {$error_stat = 1;$error_massage[].="Not add to ".$sql_tbl[products];}
							if ($itemName!="") {
								$query_answer=db_query("update  ".$sql_tbl[products]." set product='".$itemName."'  where productcode='".$itemCodeParent."'");
								if ( !$query_answer ) {$error_stat = 1;$error_massage[].="Not add to ".$sql_tbl[products];}
							}
						}

						// price update

					if($updPrice){
						// MB 21/04/2008
						//////////////////////////////////////////////////////
						//  Start Update pricing   
						//////////////////////////////////////////////////////
						$query = db_query("SELECT p.priceid, p.variantid, p.productid, p.price "
											." FROM ".$sql_tbl[variants]." v,"
													.$sql_tbl[pricing]." p "
											." where productcode='".$itemCode."'"
											." AND v.variantid = p.variantid"
											." AND v.productid = p.productid");
						$row = db_fetch_array($query);
						if (db_num_rows($query)!=0){
							//////////////////////////////////////////////////////
							//  ItemCode == Variant
							//////////////////////////////////////////////////////
//							$variantid = $row['variantid'];
//							$productid = $row['productid'];
							$webprice = $row['price'];
							$priceid = $row['priceid'];

							$query_answer=db_query("update ".$sql_tbl[pricing]
												." set price= '".$itemPrice
												."' where priceid='".$priceid."'");
							if ( !$query_answer ) {$error_stat = 1;$error_massage[].="Not upd to ".$sql_tbl[pricing];}
							else{
								if(__MB_DEBUG){
									$xmlResponse->createTag("TypeUpd",   array(), "ItemCode == Variant", $MB_DebugTag);
									$xmlResponse->createTag("MsgUpdPrice",   array(), "Update price. Old price=".$webprice.",new price=".$itemPrice, $MB_DebugTag);
								}
							}
							//	$xmlResponse->createTag("test",   array(),"ItemCode == Variant ", $item);
						}  //end if (ItemCode == Variant )
						else{
							$query = db_query("SELECT p.priceid, p.productid, p.price  "
											."FROM ".$sql_tbl[products]." pr,"
													.$sql_tbl[pricing]." p "
											." where pr.productcode='".$itemCode."'"
													." AND pr.productid = p.productid");
							$row = db_fetch_array($query);
							if (db_num_rows($query)!=0){  // if (ItemCode == ProductCode )
							//////////////////////////////////////////////////////
							//  ItemCode == ProductCode
							//////////////////////////////////////////////////////
								$webprice = $row['price'];
								$priceid = $row['priceid'];

								$query_answer=db_query("update ".$sql_tbl[pricing]
													." set price= '".$itemPrice
													."' where priceid='".$priceid."'");
								if ( !$query_answer ) {$error_stat = 1;$error_massage[].="Not upd to ".$sql_tbl[pricing];}
								else{
									if(__MB_DEBUG){
										$xmlResponse->createTag("TypeUpd",   array(), "ItemCode == ProductCode", $MB_DebugTag);
										$xmlResponse->createTag("MsgUpdPrice",   array(), "Update price. Old price=".$webprice.",new price=".$itemPrice, $MB_DebugTag);
									}
								}
							}else{
							//////////////////////////////////////////////////////
							//  ItemCodePaent == ProductCode
							//////////////////////////////////////////////////////
								$query = db_query("SELECT p.priceid, p.productid, p.price  "
												."FROM ".$sql_tbl[products]." pr,"
														.$sql_tbl[pricing]." p "
												." where pr.productcode='".$itemCodeParent."'"
														." AND pr.productid = p.productid");
								$row = db_fetch_array($query);
								if (db_num_rows($query)!=0){  // if (ItemCodeParent == ProductCode )
									$webprice = $row['price'];
									$priceid = $row['priceid'];

									$query_answer=db_query("update ".$sql_tbl[pricing]
														." set price= '".$itemPrice
														."' where priceid='".$priceid."'");
									if ( !$query_answer ) {$error_stat = 1;$error_massage[].="Not upd to ".$sql_tbl[pricing];}
									else{
										if(__MB_DEBUG){
											$xmlResponse->createTag("TypeUpd",   array(), "ItemCodeParent == ProductCode", $MB_DebugTag);
											$xmlResponse->createTag("MsgUpdPrice",   array(), "Update price. Old price=".$webprice.",new price=".$itemPrice, $MB_DebugTag);
										}
								}
								}// End if (ItemCodeParent == ProductCode )
								else{
									$error_stat=1;
									if(__MB_DEBUG){
										$xmlResponse->createTag("TypeUpd",   array(), "Not update price!", $MB_DebugTag);
									}
									$flNotUpdate =true;

								}
							}
						}

						// MB 21/04/2008
						//////////////////////////////////////////////////////
						//  End Update pricing
						//////////////////////////////////////////////////////

					}//if($updPrice)

					if($itemStock!=""){   // stock update

							// MB 17/04/2008
							//////////////////////////////////////////////////////
							//  Start Update stock
							//////////////////////////////////////////////////////

							$query = db_query("SELECT * FROM ".$sql_tbl[variants]." where productcode='".$itemCode."'");
							$row = db_fetch_array($query);
							if (db_num_rows($query)!=0){
								//////////////////////////////////////////////////////
								//  ItemCode == Variant
								//////////////////////////////////////////////////////
								$variantid = $row['variantid'];
								$webstock = $row['avail'];

								$query_answer=db_query("update ".$sql_tbl[variants]." set avail= '".$itemStock."' where variantid='".$variantid."'");
								if ( !$query_answer ) {$error_stat = 1;$error_massage[].="Not upd to ".$sql_tbl[variants];}

								$sqlstr = "
									SELECT v1.productid, SUM(v2.avail) avail_sum
										FROM xcart_variants v1
										INNER JOIN xcart_variants v2 ON v1.productid = v2.productid
										WHERE v1.productcode = '".$itemCode."'
										GROUP BY v1.productid";
								$query = db_query($sqlstr);
								$row = db_fetch_array($query);
								if ($row['productid']){
									// update product avail  according sum of its variants.
									$qry = "UPDATE ".$sql_tbl[products]." SET avail='".$row['avail_sum']."' WHERE productid ='".$row['productid']."'";
									$query_answer = db_query($qry);
									if ( !$query_answer ) {$error_stat = 1;$error_massage[].="Not add to ".$sql_tbl[products];}
								}
								//	$xmlResponse->createTag("test",   array(),"ItemCode == Variant ", $item);
							}  //end if (ItemCode == Variant )
							else{
								$query = db_query("SELECT * FROM ".$sql_tbl[products]." where productcode='".$itemCode."'");
								$row = db_fetch_array($query);
								if (db_num_rows($query)!=0){  // if (ItemCode == ProductCode )
								//////////////////////////////////////////////////////
								//  ItemCode == ProductCode
								//////////////////////////////////////////////////////
									$productid = $row['productid'];
									$webstock = $row['avail'];

									//$query_answer=db_query("update ".$sql_tbl[products]." set avail='".$itemStock."'");
									$query_answer=db_query("update ".$sql_tbl[products]." set avail='".$itemStock."' WHERE productid ='".$productid."'");
									if ( !$query_answer ) {$error_stat = 1;$error_massage[].="Not upd to ".$sql_tbl[products];}

//									$query_answer=db_query("update ".$sql_tbl[pricing]." (price) values ('".$itemPrice."') where productid='".$productid."'");
//									if ( !$query_answer ) {$error_stat = 1;$error_massage[].="Not upd to ".$sql_tbl[pricing];}

								//	$xmlResponse->createTag("test",   array(),"ItemCode == ProductCode ", $item);

								}else{
								//////////////////////////////////////////////////////
								//  ItemCodePaent == ProductCode
								//////////////////////////////////////////////////////

									$query = db_query("SELECT * FROM ".$sql_tbl[products]." where productcode='".$itemCodeParent."'");
									$row = db_fetch_array($query);
									if (db_num_rows($query)!=0){  // if (ItemCodeParent == ProductCode )
										$productid = $row['productid'];
										$webstock = $row['avail'];

										$query_answer=db_query("update ".$sql_tbl[products]." set avail=  '".$itemStock."' where productid='".$productid."'");
										if ( !$query_answer ) {$error_stat = 1;$error_massage[].="Not upd to ".$sql_tbl[products];}
										//$xmlResponse->createTag("test",   array(),"ItemCodeParent == ProductCode ".$itemCodeParent, $item);
									}// End if (ItemCodeParent == ProductCode )
									else{
										$error_stat=1;
										$flNotUpdate =true;
									}
								}
							}

							// MB 17/04/2008
							//////////////////////////////////////////////////////
							//  End Update stock
							//////////////////////////////////////////////////////

					} //if($itemStock!="")
				}
				if (isset($flNotUpdate)){
					$xmlResponse->createTag("InventoryUpdateStatus",   array(),"1", $item);
					$xmlResponse->createTag("InventoryUpdateStatusMessage",   array(), "Failed", $item, __ENCODE_RESPONSE);
				}else{
					$xmlResponse->createTag("InventoryUpdateStatus",   array(),"0", $item);
					$xmlResponse->createTag("InventoryUpdateStatusMessage",   array(), "Success", $item, __ENCODE_RESPONSE);
				}
				unset($flNotUpdate);
				break(1);
			}
		} // end global foreach
			
		if ($error_stat==1){
			if(!empty($error_massage)){$er="Problems with DB operations.";}
			$xmlResponse->createTag("StatusMessage",   array(), "Not All OK ".$er, $root, __ENCODE_RESPONSE);
		}else {$xmlResponse->createTag("StatusMessage",   array(), "All OK", $root, __ENCODE_RESPONSE);}

/*        $xmlResponse->createTag("StatusCode",   array(), "0", $envelope);
        $xmlResponse->createTag("StatusMessage", array(), "ALL OK", $envelope, __ENCODE_RESPONSE);
*/
	} break;  // end of update Orders Shipping Status Service
	}  // END OF COMMAND CASE

  header("Content-type: application/xml");
  print($xmlResponse->generate());

  //  *****************************************************
  //  FUNCTIONS Declaration

  function xmlErrorResponse($command, $code, $message, $provider, $request_id=''){

	  header("Content-type: application/xml");
	  $xmlResponse = new xml_doc('<?xml version="1.0" encoding="UTF-8"?>');
	  $root = $xmlResponse->createTag("RESPONSE", array('Version'=>'1.5'));
	  $envelope = $xmlResponse->createTag("Envelope", array(), '', $root);
	  $xmlResponse->createTag("Command", array(), $command, $envelope);
	  $xmlResponse->createTag("StatusCode", array(), $code, $envelope);
	  $xmlResponse->createTag("StatusMessage", array(), $message, $envelope);
	  if ($request_id) $xmlResponse->createTag("RequestID", array(), $request_id, $envelope);
	  //$xmlResponse->createTag("Provider", array(), $provider, $envelope);
	  return $xmlResponse->generate();
	}

  function parseSpecCharsA($arr){
    foreach($arr as $k=>$v){
      $arr[$k] = htmlspecialchars($v, ENT_NOQUOTES);
    }
    return $arr;
  }

  function isTHUBInstalled() {
    global $sql_tbl;
    $result = false;
    $sql_str = "SHOW COLUMNS FROM `" . $sql_tbl[orders] . "` LIKE 'thub_posted_to_accounting'";
    $orders_query = db_query($sql_str);
    $rows = db_fetch_array($orders_query);
    if ($rows) $result = true;
    return $result;
  }

  function THUBInstall(){
    global $sql_tbl;
    $updateQuery = "ALTER TABLE `" . $sql_tbl[orders] . "`
    ADD `thub_posted_to_accounting` VARCHAR( 1 ) ,
    ADD `thub_posted_date` DATETIME,
    ADD `thub_accounting_ref` VARCHAR( 25 )";
    $result3 = db_query($updateQuery);
    if ($result3) {
      $result4 = db_query("UPDATE `" . $sql_tbl[orders] . "` set  thub_posted_to_accounting  = 'X', thub_accounting_ref = 'HISTORY'  WHERE to_days(Now()) - TO_DAYS(FROM_UNIXTIME(`date`)) > 5");
      if (!$result4) {
            return "Update of historical orders FAILED<br>";
      }
    } else {
      return "ALTER order table FAILED<br>";
    }
    return '';
  }

class timerClass {
	var $startTime;
	var $started;

	function timerClass($start=true) {
		$this->started = false;
		if ($start)
			$this->start();
	}

	function start() {
		$startMtime = explode(' ',microtime());
		$this->startTime = (double)($startMtime[0])+(double)($startMtime[1]);
		$this->started = true;
	}

	function end($iterations=1) {
		// get the time, check whether the timer was started later
		$endMtime = explode(' ',microtime());
		if ($this->started) {
			$endTime = (double)($endMtime[0])+(double)($endMtime[1]);
			$dur = $endTime - $this->startTime;
			$avg = 1000*$dur/$iterations;
			$avg = round(1000*$avg)/1000;
			return "$avg milliseconds";
		} else {
			return "timer not started";
		}
	}
}
?>